function dphidtau = dualdot4(t,phi,C,K,Kp,theta)

% function dphidtau = dualdot4(t,phi,C,K,Kp,theta);
% finds approximate solution to
% C(h) phidot = - K(h)*phi_xx - K'(h) phi_x
% IC phi(x,T) = 0;
% BC Kbar phi_x = theta(:,2) at phi = theta(:,3) at x=1
% tau = T - t;
% I solve in tau coords, which switches sign of dt
% Cbar phidot =  Kbar*phi_xx + K' phi_x
% where K' is taken as constant in interval

global XXX
x = XXX(:);

dx = diff(x);

[M,N] = size(phi);

theta0 = myinterp1(theta(:,1:2),t);
theta1 = myinterp1(theta(:,1:2:3),t);
phi = [NaN ; phi ; NaN]; 
%K0 = myinterp1(app_K,phi(2));
%phi(1) = phi(2) - dx(1)*theta0/K(1);
phi(1) = phi(2) - dx(1)*theta0/K;
%phi(1) = phi(2) - dx(1)*theta0/K0;
phi(end) = theta1;

%KK = myinterp1(app_K,phi);

phidot = K.*(phi(1:M)-2*phi(2:M+1)+phi(3:M+2))./(dx(1).^2)...
         + Kp.*(phi(3:M+2)-phi(1:M))./(2*dx(1)); 
%phidot = KK(2:M+1).*(phi(1:M)-2*phi(2:M+1)+phi(3:M+2))./(dx(1).^2)...
%         + Kp.*(phi(3:M+2)-phi(1:M))./(2*dx(1)); 

dphidtau = phidot;
