function  [sol,tspan,u0] = solve_forward(Solver,Udot,tspan,u0,C,K,BCs,time_w,state_w,indx,level);

global XXX

if indx == 1
  pts = time_w(level);
  options = odeset('BDF','on','Events',@compare_t,'Mass',@mass,...
                  'RelTol',1e-8,'AbsTol',1e-11,'MStateDependence','strong');
elseif indx == 2
  pts = state_w(level);
  options = odeset('BDF','on','Events',@compare_s,'Mass',@mass,...
                  'RelTol',1e-8,'AbsTol',1e-11,'MStateDependence','strong');
else
  error('Bad stopping crit');
end

ts = min(tspan);
flag = [];

% forces u0 to be nonpositive
%u0 = min(u0(1:end),0);

sol = feval(Solver,str2func(Udot),tspan,u0,options,C,K,BCs,pts);

if isempty(sol.xe);
%  fprintf('Last interval, [%0.2g %0.2g], is too small.\n',min(tspan),max(tspan));
  tf = max(tspan);
  flag = 1;
else 
  tf = sol.xe;  
  flag = 0;
  u0 = sol.ye;
end;
 
tspan = [ts,tf];

%------------------------------

function [value,isterminal,direction] = compare_t(t,u,C,K,BCs,pts)

 
value = t - pts;  % stops at certain time

isterminal =  1 ;
direction =  1;

%---------------------------------

function [value,isterminal,direction] = compare_s(t,u,C,K,BCs,pts)

 
value = pts - min(u);  % stops at certain time

isterminal =  1 ;
direction =  1;

%---------------------------------

function out = mass(t,u,C,K,BCs,pts)

d = evaluate(C,u);
out = sparse(diag(d));
