function [DP,DQ,DTSPAN,app_K,app_C,MM,BB,limflag] = suction1(dataname);

%uses state/time breaks 

% Tue Mar  9 09:33:05 MST 2004

%---------------------

global XXX TTT

%--------------------- load data

full_data = load(strcat(pwd,filesep,'data',filesep,dataname));

C0 = full_data(1);
K0 = full_data(2);
Xmin = full_data(1,end);
Xmax = full_data(2,end);

data = full_data(3:end,:);
BCs = data(:,1:3);

te = data(:,1);
mp = data(:,4);
mq = data(:,5);
ex_data = [ te , mp , mq ];

% ------------------- read parameters

parameter;

if (sindx == 1)
  disp('Hard coded time breaks');
elseif (sindx == 2)
   disp('Hard coded state breaks');
else
   error('No stopping method given');
end

%--------------------
%build space grid
x = linspace(Xmin,Xmax,Xstep);       % x grid arbitrary
XXX = x;                             % Triple Caps are global
dt = min(diff(te));

% compute minimum of init/boundary conditions
minu = min([mp;min(BCs(:,3))]);

init_C = [ 0 , C0 ];     %  This is presumed to be known
init_K = [ 0 , K0];

app_C = [  init_C ;
    bp-1 , C0 ] ;     % approx_C is the form [ u , D(u) ]
app_K = [  init_K ;
    bp-1 , K0 ] ;     % approx_K is the form [ u , D(u) ]

t = linspace(min(te),max(te));  %current tgrid, will quickly change

iter = 1;  % count of strips
Tmax = max(t);  %     just to get loop started
ts = min(t);
limflag = 0;

% Continue while in experimental time interval
while( ts<Tmax  )
  % cycle could be set to 1:Maxit
  for cycle = 1:Maxit
  %disp('cycle set to 1');
    ts = min(t);                    %ts is smallest time
    u0 = 0*x(2:end-1)'; ts = t(1);  % u0 is set to 0
    
    % clear the update functions I use
    M = []; b = []; dCK = []; dC = []; dK = [];
    level = 1;                      % level counts strip number
    while( level<= iter & ts <= Tmax)  % iteration counts strips
 %       for level = 1:2
        tspan_0 = [ts,Tmax];
        [sol, tspan, u0] = solve_forward(Solver2, Udot, tspan_0,...
                           u0,app_C,app_K,BCs,...
                           Time_w,State_w,sindx,level);
        %begin to construct nodes and values of numerical solution
        % that coincide with experimental data
        [c_nodes,c_tspan] = find_nodes(te,tspan);
        % keyboard;
        [c_tspan,c_u,c_p,c_q] = make_data(sol,c_tspan,app_K,BCs);
        % make delta p (state at z = 0)
        % and delta q (flux at z = 1)
        dp{level} = mp(c_nodes) - c_p;
        dq{level} = mq(c_nodes) - c_q;
        % store some of these values 
        c_te{level} = te(c_nodes);
        ts = max(tspan);
        dsol{level} = sol;
        dtspan{level}= tspan;
        DTSPAN{level,cycle}= tspan;
        DP{level,cycle} = dp{level};
        DQ{level,cycle} = dq{level};
        level = level+1;
    end   % end while loop (direct problem is finished)
 
    for i = iter   %loop for dual problem
        phi0.one = 0 * XXX(2:end-1)';
        phi0.two = phi0.one;
        disp('Fix dual_K and dual_kp here')
        dual_kp = 0;  % check this 
        %dual_K = 1+(0)*XXX'; % check this 
        dual_K = mean(app_K(:,2));
        %dual_K = app_k;
        cdp = max(dp{i});
        cdq = max(dq{i});
        theta.one = [c_te{i} , 1+0*dp{i}(end:-1:1) ,  0*dq{i}(end:-1:1)];
        theta.two = [c_te{i} , 0*dp{i}(end:-1:1), -2+dq{i}(end:-1:1)];
        dual= solve_dual(Solver3,Phidot,dtspan{i},phi0,app_C,dual_K,dual_kp,theta);
        dualsol{i} = dual;
    end
     col2 = [];   

%    for i = 1:iter
    for i = iter
        index = find(dsol{i}.x<max(dtspan{i}));
        common_t = union(dtspan{i},dsol{i}.x(index));
        common_tau = min(common_t) + max(common_t) - common_t;
        common_tau(1) = common_t(end);
        common_tau(end) = common_t(1);
        u = deval(dsol{i},common_t); 
        phi = deval(dualsol{i}.one,common_tau);
        psi = deval(dualsol{i}.two,common_tau);
        u = fix_b(u,common_t,BCs);
        phi = fix_b(phi,common_tau,theta.one);
        psi = fix_b(psi,common_tau,theta.two);
        T{i} = common_t;U{i} = u;PHI{i} = phi;PSI{i} = psi;
       % fix bcs u phi and psi
        [ut,ux] = gradient(u,common_t,XXX);
        [phit,phix] = gradient(phi,common_t,XXX); 
        [psit,psix] = gradient(psi,common_t,XXX);
        col1(i) = min([u(1,:),u(end,:)]);
        loweru = col1(i);
        if (i == 1)
            upperu = max(max(u));
        else
           upperu = col1(i-1);
        end
        mask = ( u >= loweru | u < upperu );
        lam = (u - upperu)./ (loweru - upperu);
        MASK{i} = mask;LAM{i} = lam;
        PHIX{i} = phix;PSIX{i} = psix;PHIT{i} = phit;PSIT{i} = psit;
        M(1,1) = integrate(mask.*lam.*(ux-1).*phix,common_t,XXX);
        M(1,2) = integrate(mask.*lam.*ut.*phi,common_t,XXX);
        M(2,1) = integrate(mask.*lam.*(ux-1).*psix,common_t,XXX);
        M(2,2) = integrate(mask.*lam.*ut.*psi,common_t,XXX);
        Pstar =  myinterp1(theta.one(:,1:2),c_te{i});
        Qstar =  myinterp1(theta.two(:,1:2:3),c_te{i});
        fprintf('\nUsing %i data points.\n',length(c_te{i}));
        if length(c_te{i})<4  %uses at least four points for integral
           b(1,1) = 0;b(2,1) = 0;
        else
           b(1,1) = trapz(c_te{i},dp{i}.*Pstar);
           b(2,1) = trapz(c_te{i},dq{i}.*Qstar);
        end
        MM{i,cycle} = M; BB{i,cycle} = b;
        col2 = [];
        col2(2*i-1:2*i,1) = M \b;
    end

    oldK = myinterp1(app_K,col1);
    oldC = myinterp1(app_C,col1);
    dK = col2(1:2:end)
    itflag = 0;
    if norm(dK>0,inf) > 0
       dK;
       fprintf('Do nothing');
%       dK = (dK<=0).*dK;   % limit dK to be monotone 
%       fprintf('limiting dK update and iterating');
%       itflag = 1;
    end
    dC = col2(2:2:end);
    dKKK{iter} = dK;
    dCCC{iter} = dC;
    app_K = [];
    app_C = [];
    app_K = [ init_K;
             col1' , oldK'+dK];
    app_K = [app_K ; 
             app_K(end,1)*1.01, app_K(end,2)];
    app_K(:,2) = max(app_K(:,2),Kmin); %limit update
    app_C = [ init_C;
             col1' , oldC'+dC];
    app_C = [app_C ; 
             app_C(end,1)*1.01, app_C(end,2)];
    app_C(:,2) = max(app_C(:,2),Cmin);
    if (min(app_C(:,2)) == Cmin) | (min(app_K(:,2)) == Kmin)
        disp('Limited coefficient.  Continue?');
        %keyboard
        limflag = limflag + 1;
        itflag = itflag + 1;
    end
  end   
  iter = iter+1-itflag;
end

